Lua_FirstRechargeHeroOnePanel = class("Lua_FirstRechargeHeroOnePanel", Lua_ListCell);
function Lua_FirstRechargeHeroOnePanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FirstRechargeHeroOnePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showItemArr = Array();

	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "default", 0, 0, 720, 768);
	self.bg.alpha = 0.01;
	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);
end

function Lua_FirstRechargeHeroOnePanel:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self:playFRTween();
end

function Lua_FirstRechargeHeroOnePanel:playFRTween()
	for i = 1, self.showItemArr:getSize() do
		self.showItemArr[i]:stopPlayEff();
		self.showItemArr[i]:setEnable(false);
	end

	local panelType = DataCenter.firstRechargeData.selectPanelType;
	local heroInfoDic = DataCenter.firstRechargeData.heroInfoDic[panelType][self._data.grade];
	local heroIdDic = heroInfoDic.hero_id_list;
	local state = heroInfoDic.is_play == 1;
	local item;
	for i = 1, #heroIdDic do
		item = self.showItemArr[i];
		if item == nil then
			item = Lua_FirstRechargeHeroOneItem.new(self.content);
			self.showItemArr:add(item);
		end
		item:setEnable(false);
		item:setData({grade = self._data.grade, index = i, isShowPlay = state});
		item:setLocation(0, 0, 0);
	end
end

function Lua_FirstRechargeHeroOnePanel:onBgClick(go)
end

function Lua_FirstRechargeHeroOnePanel:dispose()
	if self.starInfoArr ~= nil then
		self.starInfoArr:dispose();
		self.starInfoArr:clear();
	end
	self._data = nil;
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FirstRechargeHeroOneItem = class("Lua_FirstRechargeHeroOneItem", Lua_DisplayObject);
function Lua_FirstRechargeHeroOneItem:ctor(p)
	self:superCall("ctor", p, "FirstRechargeHeroItem_skin");
end

function Lua_FirstRechargeHeroOneItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroInfoIcon:addClickFuntion(self, self.onheroClick);
end

function Lua_FirstRechargeHeroOneItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.isFirst = true;

	local panelType = DataCenter.firstRechargeData.selectPanelType;
	self.heroInfo = DataCenter.firstRechargeData.heroInfoDic[panelType][data.grade];
	if data.isShowPlay then -- 播放动画
		self.heroImg:removeLoadCompleteFun(self, self.onLoadCompletedFun);
		self.showStep = 1;
		self.showSubStep = 1;
		self:setImgInfo(self.showStep);
		self:startPlayEff();
	else
		self.heroImg:addLoadCompleteFun(self, self.onLoadCompletedFun);
		local imgInfo = self.heroInfo.hero_img_list[data.index];
		self:setImgInfo(#imgInfo);
	end
end

function Lua_FirstRechargeHeroOneItem:setImgInfo(step)
	local imgInfo = self.heroInfo.hero_img_list[self._data.index];
	self.heroImg:setUrl(self.heroInfo.hero_url .. imgInfo[step]);

	local spriteDic = self.heroInfo.hero_info_list[self._data.index];
	local infoPos = self.heroInfo.hero_info_pos[self._data.index];
	local readPos = self.heroInfo.target_pos[self._data.index];
	self.heroInfoIcon:setAltas(self.heroInfo.hero_info_atlas, spriteDic[step]);
	self.heroInfoIcon:setLocation(infoPos[step][1], infoPos[step][2]);
	self.heroReadBtn:setLocation(readPos[step][1], readPos[step][2]);
end

-- 播放动画：播放时间，延迟时间，位置，旋转，缩放，回调函数，偏移
function Lua_FirstRechargeHeroOneItem:startPlayEff()
	local moveTypeDic = self.heroInfo.move_list[self._data.index][self.showStep][self.showSubStep];
	if moveTypeDic == nil then
		return;
	end

	local posX;
	local posY;
	if moveTypeDic[1] == 1 then -- 右 → 左
		posX = moveTypeDic[2];
		posY = self.y;
	elseif moveTypeDic[1] == 2 then -- 左 → 右
		posX = moveTypeDic[2];
		posY = self.y;
	elseif moveTypeDic[1] == 3 then -- 上 → 下
		posX = self.x;
		posY = moveTypeDic[2];
	else
		posX = self.x;
		posY = self.y;
	end
	-- print(self._data.index, self.showStep, self.showSubStep, posX, posY);

	-- 开始播放
	local firstTime = self.isFirst and 0.1 or 0.8;
	if self.isFirst then
		self.isFirst = false;
	end

	TweenUtil.getInstance():addTween(self.mainContent, firstTime, 0,
	posX, posY, 0,
	0, 0, 0,
	1, 1, 1,
	self, self.movePlayEff, 0, false);
end

-- 移动
function Lua_FirstRechargeHeroOneItem:movePlayEff()
	self.mainContent:SetActive(true);
	TweenUtil.getInstance():addTween(self.mainContent, 1, 0,
	self.x, self.y, 0,
	0, 0, 0,
	1, 1, 1,
	self, self.overPlayEff, 0, false);
end

function Lua_FirstRechargeHeroOneItem:overPlayEff()
	self:setImgInfo(self.showStep);
	local moveDic = self.heroInfo.move_list[self._data.index]; -- 区分左右播放
	local moveInfoDic = moveDic[self.showStep]; -- 区分播放第几步的英雄立绘
	if moveInfoDic[self.showSubStep + 1] ~= nil then -- 英雄立绘停顿显示
		self.showSubStep = self.showSubStep + 1;
		self:startPlayEff();
	else
		self.showSubStep = 1;
		if moveDic[self.showStep + 1] ~= nil then
			TweenUtil.getInstance():addTweenTargetAlpha(self.mainContent, 0.6, 0, -1, true, self, self.endAlhpaFun);
			self.showStep = self.showStep + 1;
			self:startPlayEff();
		else
			if self.heroInfo.is_loop == 1 then
				TweenUtil.getInstance():addTweenTargetAlpha(self.mainContent, 0.6, 0, -1, true, self, self.endAlhpaFun);
				self.showStep = 1;
				self.showSubStep = 1;
				self:startPlayEff();
			else
				self:stopPlayEff();
			end
		end
	end
end

function Lua_FirstRechargeHeroOneItem:endAlhpaFun()
	self:setImgInfo(self.showStep);
end

function Lua_FirstRechargeHeroOneItem:stopPlayEff()
	TweenUtil.getInstance():stop(self.mainContent);
end

function Lua_FirstRechargeHeroOneItem:onLoadCompletedFun()
	self.mainContent:SetActive(true);
end

function Lua_FirstRechargeHeroOneItem:onheroClick(go)
	local panelType = DataCenter.firstRechargeData.selectPanelType;
	local heroIdDic = DataCenter.firstRechargeData.heroInfoDic[panelType][self._data.grade].hero_id_list[self._data.index];
	local heroId;
	if self._data.isShowPlay then
		heroId = heroIdDic[self.showStep];
	else
		heroId = heroIdDic[#heroIdDic];
	end
	DataCenter.heroAtlasData:onOpenAtlasWindow(heroId);
end

function Lua_FirstRechargeHeroOneItem:dispose()
	self.heroInfo = nil;
	self._data = nil;
	self:stopPlayEff();

	self:superCall("dispose");
end