-- 首充版本2
checkRequire("Lua_FirstRechargeHeroOnePanel");
Lua_FirstRechargeTwoPanel = class("Lua_FirstRechargeTwoPanel", Lua_DisplayObject);
function Lua_FirstRechargeTwoPanel:ctor(p)
	self:superCall("ctor", p, "FirstRechargeOnePanel_skin");
end

function Lua_FirstRechargeTwoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg.mouseEnable = true;

	-- 英雄信息
	self.heroInfoPanel = Lua_FirstRechargeHeroOnePanel.new(self.content);
	self.heroInfoPanel:setSiblingIndex(1);
	self.heroInfoPanel:setRectAnchor(7);
	self.heroInfoPanel:setLocation(0, 866, 0);

	-- 挡位
	local panelType = DataCenter.firstRechargeData.selectPanelType;
	local heroInforArr = DataCenter.firstRechargeData.heroInfoDic[panelType];
	local btnInfo = Array();
	for i = 1, heroInforArr:getSize() do
		btnInfo:add({ textStr = heroInforArr[i].money});
	end
	self.btnList = Lua_ButtonList.new(self.uitweenObj_1, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, 243, 0);
	self.btnList:setButtonCell(Lua_FirstRechargeTwoBtnItem);
	self.btnList:setButtonItem(246, 75);
	-- self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(btnInfo);

	-- 激活奖励
	self.actedIcons = Lua_ItemIconList.new(self.uitweenObj_1);
	self.actedIcons.canClick = true;
	self.actedIcons:setLayout(190, 0, 10);
	self.actedIcons:setLocation(-166, 131, 0);

	-- 每日奖励
	self.rewardList = Lua_DragList.new(self.uitweenObj_1, 700, 154, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_FirstRechargeTwoRewardItem, 285, 154, 1);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(0, 117, 0);

	self.tipsIcon.clickScale = false;
	self.tipsIcon:addClickFuntion(self, self.onBgClick);
	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_FirstRechargeTwoPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_FirstRechargeTwoPanel:updatePanelInfo()
	-- 首次进入显示有可领取奖励的页签（没有时默认第一个页签），其他只刷新页签
	if self.isFirstIn ~= true then
		self.isFirstIn = true;
		self.btnList:setSelected(DataCenter.firstRechargeData.showIdx);
	else
		self:updateBtnSelect();
	end
end

function Lua_FirstRechargeTwoPanel:onBtnClick(val)
	self.selectType = val;
	self.heroInfoPanel:setData({grade = val});
	self:updateBtnSelect();
end

function Lua_FirstRechargeTwoPanel:updateBtnSelect()
	local firstRechargeData = DataCenter.firstRechargeData;
	local info = firstRechargeData.heroInfoDic[firstRechargeData.selectPanelType][self.selectType];
	self.tipsIcon:setAltas(info.des_icon[1], info.des_icon[2]);
	self.tipsIcon:SetDimensions(0, 0);
	self.tipsIcon:resetSize();

	self.chargedTxt.text = LanUtil.formateStr(201500, firstRechargeData.totalRecharge, info.money);
	self.chargedTxt:setEnable(firstRechargeData.totalRecharge < info.money);

	local actedDay = firstRechargeData.actDayDic[self.selectType];
	local drawCount = firstRechargeData.drawCountDic[self.selectType];
	local rewardInfoArr = firstRechargeData.firstRechargeDic[self.selectType];
	local toIdx = drawCount + 1 > rewardInfoArr:getSize() and rewardInfoArr:getSize() or drawCount + 1;
	local actReward = firstRechargeData.actReward;
	if self.selectType == 1 then
		self.actedIcons:setArrayData(actReward.reward);
		local tvo;
		for i = 1, 2 do
			tvo = Lua_ToolVo.createToolVo(actReward.reward[i][1]);
			self["tipsTxt_" .. i].text = tvo.name;
		end

		self.rewardList.canDrag = false;
		self.rewardList:setContentRect(285, 154)
		self.rewardList:setLocation(40, 117);
		self.rewardList:setArrayData(rewardInfoArr);
		self.rewardList:moveToIndex(toIdx, true, false);
	else
		self.rewardList.canDrag = true;
		self.rewardList:setContentRect(700, 154);
		self.rewardList:setLocation(-350, 117);
		self.rewardList:setArrayData(rewardInfoArr);
		self.rewardList:moveToIndex(toIdx, true, false); -- 由显示已激活天数改为第一个未领取的
	end
	self.actedIcons:setEnable(self.selectType == 1);
	self.actedIcons:setItemDrawMaskState(actedDay > 0 and actReward.drawState);
	self.actRewardObj:SetActive(self.selectType == 1);

	local state;
	if actedDay == 0 then
		state = false;
		self.rechargeTxt:setLangValue(201501); -- 充点小钱
	else
		if self.selectType == 1 then
			state = actReward.drawState;
		else
			state = not (drawCount < actedDay and drawCount < rewardInfoArr:getSize());
		end
		if not state then
			self.rechargeTxt:setLangValue(201502); -- 领取
		else
			self.rechargeTxt:setLangValue(201503); -- 已领取
		end
	end
	self.rechargeBtn:setGray(state);
end

function Lua_FirstRechargeTwoPanel:onBgClick(go)
end

function Lua_FirstRechargeTwoPanel:onRechargeClick(go)
	local actedDay = DataCenter.firstRechargeData.actDayDic[self.selectType];
	if actedDay == 0 then
		DataCenter.funcPathUtil:gotoFunction(1024);
	else
		if self.selectType == 1 then
			local actReward = DataCenter.firstRechargeData.actReward;
			if not actReward.drawState then
				Lua_ProxyManager.getProxy("Lua_FirstRechargeProxy"):sReceiveRecharge(actReward.id);
			end
		else
			local drawCount = DataCenter.firstRechargeData.drawCountDic[self.selectType];
			local rewardInfoArr = DataCenter.firstRechargeData.firstRechargeDic[self.selectType];
			if drawCount < actedDay and drawCount < rewardInfoArr:getSize() then
				Lua_ProxyManager.getProxy("Lua_FirstRechargeProxy"):sReceiveRecharge(rewardInfoArr[drawCount + 1].id);
			end
		end
	end
end

function Lua_FirstRechargeTwoPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.actedIcons ~= nil then
		self.actedIcons:dispose();
		self.actedIcons = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.isFirstIn = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_FirstRechargeTwoBtnItem = class("Lua_FirstRechargeTwoBtnItem", Lua_ButtonCell);
function Lua_FirstRechargeTwoBtnItem:ctor(p)
	self:superCall("ctor", p, "FirstRechargeOneBtnItem_skin");
end

function Lua_FirstRechargeTwoBtnItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FirstRechargeTwoBtnItem:dispose()
	self:superCall("dispose");
end

function Lua_FirstRechargeTwoBtnItem:setData(data)
	if data == nil then
		return;
	end
	
	self.moneyTxt.text = data.textStr;
	self.moneyTxt:resetSize();
	self.desTxt:setLangValue(201504);
	self.desTxt:resetSize();
	local width = self.desTxt.width - self.moneyTxt.width;
	LuaUtil.setObjPos(self.txtObj, -width / 2, 0, 0);
end

function Lua_FirstRechargeTwoBtnItem:setSelected(index)
	if index == self.index then -- 选中
		self.itemBg:setAltas("firstrecharge_atlas", "xui_sc_btn_2_n");
		self.moneyTxt.colorStr = Lua_ColorDefine.transColor("713B19");
		self.desTxt.colorStr = Lua_ColorDefine.transColor("713B19");
	else
		self.itemBg:setAltas("firstrecharge_atlas", "xui_sc_btn_2_h");
		self.moneyTxt.colorStr = Lua_ColorDefine.transColor("E7DCC6");
		self.desTxt.colorStr = Lua_ColorDefine.transColor("E7DCC6");
	end
end

function Lua_FirstRechargeTwoBtnItem:setCanClick(bCan)
	if bCan == true then
		self.itemBg.mouseEnable = true
		self.itemBg:addClickFuntion(self, self.onPressClick)
	else
		self.itemBg.mouseEnable = false
		self.itemBg:removeClickFuntion(self, self.onPressClick)
	end
end





--------------------------------------------------





Lua_FirstRechargeTwoRewardItem = class("Lua_FirstRechargeTwoRewardItem", Lua_ListCell);
function Lua_FirstRechargeTwoRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FirstRechargeTwoRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcons = Lua_ItemIconList.new(self.content);
	self.itemIcons:setLayout(131, 0, 10);
	self.itemIcons:setLocation(0, 14, 0);

	self.dayTxt = UICreate.createLabel(self.content, "", 0, -64, 0, 30, 26);
	self.dayTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.dayTxt.alignmentValue = 4;
	self.dayTxt.horizontalOverflowValue = 1;
	self.dayTxt.colorStr = Lua_ColorDefine.transColorStr("E7DCC6");
	self.dayTxt.effectStyle = 2;
	self.dayTxt.effectColorStr = Lua_ColorDefine.transColor("63322A");
	self.dayTxt:setEffectDistance(1, 1);
end

function Lua_FirstRechargeTwoRewardItem:setData(data)
	if data == nil then
		return;
	end
	
	self.itemIcons:setArrayData(data.reward);

	if data.grade == 1 then
		self.itemIcons:setItemDrawMaskState(DataCenter.firstRechargeData.oneDrawState);
		local rewardInfoArr = DataCenter.firstRechargeData.firstRechargeDic[data.grade];
		self.dayTxt.text = LanUtil.formateStr(201505, convert_arab_to_chinese(rewardInfoArr:getSize()));
	else
		self.itemIcons:setItemDrawMaskState(data.drawState);
		self.dayTxt.text = LanUtil.formateStr(201506, convert_arab_to_chinese(data.day));
	end
end

function Lua_FirstRechargeTwoRewardItem:onPressClick()
	self.itemIcons:onBoundClick();
end

function Lua_FirstRechargeTwoRewardItem:dispose()
	if self.itemIcons ~= nil then
		self.itemIcons:dispose();
		self.itemIcons = nil;
	end
	if self.dayTxt ~= nil then
		self.dayTxt:dispose();
		self.dayTxt = nil;
	end

	self:superCall("dispose");
end