-- 首充
Lua_FirstRechargeWindow = class("Lua_FirstRechargeWindow", Lua_Window);
function Lua_FirstRechargeWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showClose = true;
	self.btnCloseAtlas = "firstrecharge_atlas";
	self.btnCloseSprite = "xui_sc_btn_1_n";
	self.btnClosePosX = 303;
	self.btnClosePosY = 529;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -626;
end

function Lua_FirstRechargeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.clickTime = getTime();

	self.closeText.anchor = Lua_WindowUtil.getAnchor(7);
	self.closeText:setLocation(0, 92, 0);

	-- 首充有新版本可以在这里进行添加
	self.panelInfo = Array();
	self.panelInfo:add({ panel = "Lua_FirstRechargeOnePanel" });
	self.panelInfo:add({ panel = "Lua_FirstRechargeTwoPanel" });
	self.panelInfo:add({ panel = "Lua_FirstRechargeThirdPanel" });

	self:addLuaEvent("SHOW_FIRSTRECHARGE", self, self.initPanel);
	Lua_ProxyManager.getProxy("Lua_FirstRechargeProxy"):sFirstRechargeInfo();
end

function Lua_FirstRechargeWindow:initPanel()
	local panelType = DataCenter.firstRechargeData.selectPanelType;
	if self.panelType ~= panelType then
		if self.curPanel ~= nil then
			self.curPanel:dispose();
			self.curPanel = nil;
		end

		local showPanel = checkRequire(self.panelInfo[panelType].panel);
		self.curPanel = showPanel.new(self.content);
		self.curPanel:setSiblingIndex(0);
		self.curPanel:setRectAnchor(9);

		if self.tweenName ~= nil then
			DataCenter.winTweenManager:removeWinTween(self.tweenName);
		end
		self.tweenName = DataCenter.winTweenManager:createWinTween(self.curPanel.content.name, self.content.transform);
	end
	self.panelType = panelType;
	self.curPanel:updatePanelInfo();
end

function Lua_FirstRechargeWindow:hide()
	if getTime() - self.clickTime < 1 then
		return;
	end
	self:superCall("hide");
end

function Lua_FirstRechargeWindow:dispose()
	if self.panelInfo ~= nil then
		self.panelInfo:dispose();
		self.panelInfo:clear();
		self.panelInfo = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	DataCenter.winTweenManager:removeWinTween(self.tweenName);

	self:superCall("dispose");
end